defmodule ChronoscopeWeb.API.V1.NTS.KeyEstablishmentController do
  use ChronoscopeWeb, :controller

  require Logger

  alias Chronoscope.NTS

  @default_port "4460"

  def get(conn, params) do
    host = params["host"]
    port = String.to_integer(params["port"] || @default_port)

    case NTS.key_establishment(host, port) do
      {:ok, response} ->
        json(conn, %{status: :ok, response: format_response(response)})

      {:error, error} ->
        json(conn, %{status: :error, reason: to_string(error)})
    end
  end

  defp format_response(response) do
    response
    |> Map.take([:aead_algorithms, :cert_expiration, :cookie_length, :cookies, :next_protocols, :port, :server])
    |> Map.update(:cookies, 0, &length/1)
  end
end
